PROGRAM automata (input, output);
        USES Crt, ListaMat, ListaEst, ListaEnt;

        TYPE
            listaEntrada = TipoListaEnt;
            listaMatrices = TipoListaMat;
            listaEstados = TipoListaEst;
            listaEstadosFinales = TipoListaEst;
            vectInicial = ARRAY [1..10] of real;
            matrAFD = ARRAY [1..11,1..11] of char;
        VAR
            entrada : listaEntrada;
            estados : listaEstados;
            matrices : TipoListaMat;
            vectorInicial : vectInicial;
            vector, vector2 : vectInicial;
            umbral : real;
            estadosFinales : listaEstadosFinales;
            matrizAFD: matrAFD;
            estadoInicialAFD: char;

            numEntradas : Integer;
            numEstados : Integer;
            numEstadosFinales : Integer;
            palabra : String;
            c: char;

PROCEDURE MostrarMatriz (matr: matriz);
var
   i, j: integer;
BEGIN

     FOR i:=1 TO numEstados DO
     BEGIN
         FOR j:=1 TO numEstados DO
             Write (matr[i,j]:1:0,', ');
         Writeln;
     END;
END;

PROCEDURE MostrarMatrizReales (matr: matriz);
var
   i, j: integer;
BEGIN

     FOR i:=1 TO numEstados DO
     BEGIN
         FOR j:=1 TO numEstados DO
             Write (matr[i,j]:2:2,', ');
         Writeln;
     END;
END;



PROCEDURE BorrarPantalla;
VAR
   i: integer;
BEGIN
     FOR i:= 1 TO 24 DO
         writeln ('                                                                               ');
     gotoxy (1,1);
END;

PROCEDURE LeerFicheros;
VAR
   ficheroEntradas : text;
   ficheroMatrices : text;
   ficheroEstados : text;
   ficheroEstadosFinales : text;
   ficheroVectorInicial: text;
   matrizAux : matriz;
   numero : integer;
   numreal: real;
   caracter : Char;
   error : Integer;
   cadena: string;
   i, j, k: Integer;
BEGIN
     (* ************ Leer del fichero ESTADOS ************* *)
     ASSIGN ( ficheroEstados, 'A:\estados.txt' );
     RESET ( ficheroEstados );
     ReadLn ( ficheroEstados, caracter );
     Val ( caracter, numEstados, error );
     estados.CrearVacia;
     FOR i:=1 TO numEstados DO
     BEGIN
          ReadLn ( ficheroEstados, caracter );
          estados.Anadir(caracter);
     END;
     Close ( ficheroEstados );

     (* ************ Leer del fichero ESTADOS FINALES ****** *)
     ASSIGN ( ficheroEstadosFinales, 'a:\finales.txt' );
     RESET ( ficheroEstadosFinales );
     ReadLn ( ficheroEstadosFinales, caracter );
     Val ( caracter, numEstadosFinales, error );
     estadosFinales.CrearVacia;
     FOR i:=1 TO numEstadosFinales DO
     BEGIN
          ReadLn ( ficheroEstadosFinales, caracter );
          estadosFinales.Anadir (caracter);
     END;
     Close ( ficheroEstadosFinales );

     (* ************ Leer del fichero VECTOR INICIAL ******* *)
     ASSIGN ( ficheroVectorInicial, 'a:\inicial.txt' );
     RESET ( ficheroVectorInicial );
     FOR i:=1 TO numEstados DO
     BEGIN
          ReadLn ( ficheroVectorInicial, cadena);
          val (cadena, numreal, error);
          VectorInicial[i]:= numreal;
     END;
     Close (ficheroVectorInicial);

     (* ************ Leer del fichero ENTRADAS ********** *)
     ASSIGN ( ficheroEntradas, 'a:\entradas.txt' );
     RESET ( ficheroEntradas );
     ReadLn ( ficheroEntradas, cadena );
     Val ( cadena, numEntradas, error );
     entrada.CrearVacia;
     FOR i:=1 TO numEntradas DO
     BEGIN
          ReadLn ( ficheroEntradas, cadena );
          Val ( cadena, numero, error );
          entrada.Anadir (numero);
     END;
     Close ( ficheroEntradas );

     (* ************* Leer del fichero MATRICES ************ *)
     ASSIGN ( ficheroMatrices, 'a:\matrices.txt' );
     RESET ( ficheroMatrices );
     matrices.CrearVacia;
     FOR k:=0 TO numEntradas-1 DO
     BEGIN
          FOR i:=1 TO numEstados DO
              FOR j:=1 to numEstados DO
              BEGIN
                   ReadLn ( ficheroMatrices, cadena );
                   Val ( cadena, matrizAux[i,j], error );
              END;
          matrices.Anadir (matrizAux);
          (*mostrarMatriz(matrizAux);*)
          matrices.Enesimo (k, matrizAux);
          (*mostrarMatriz(matrizAux);*)
     END;
     Close ( ficheroMatrices );
END;



PROCEDURE PedirDatos;
VAR
   estadoInicial, i, num : Integer;

BEGIN
     WriteLn ('Escriba el umbral...');
     ReadLn ( umbral );
     Write ('Dado que las entradas son :');
     FOR i:=1 TO numEntradas DO
     BEGIN
          entrada.Enesimo (i, num);
          Write (num,' ');
     END;
     WriteLn;
     WriteLn ('Escriba una palabra para ver si es aceptada... ');
     ReadLn ( palabra );
END;

PROCEDURE CalcularPalabra;
VAR
   numero, error: integer;
   matr: matriz;
   i, j, k: integer;
   car: char;
   pos: Integer;
   prob: real;
BEGIN
     vector := vectorInicial;
     FOR i:=1 TO length( palabra ) DO
     BEGIN
          val (palabra[i], numero, error);
          matrices.Enesimo (numero, matr);
          FOR j:=1 TO numEstados DO
          BEGIN
               vector2[j]:=0;
               FOR k:=1 TO numEstados DO
               BEGIN
                    vector2[j]:= vector2[j] + vector[k]*matr[k,j];
               END;
          END;
          vector:= vector2;
     END;
     Writeln ('El vector resultante es: ');
     FOR i:=1 TO numEstados DO
         Write (vector[i]:2:2,' ');
     Writeln;
     i:=1;
     prob:=0;
     REPEAT
          estadosFinales.Enesimo (i, car);
          pos:= estados.Posicion (car);
          prob:=prob + vector[pos];
          i:=i+1;
     UNTIL (i>numEstadosFinales);
     IF prob>umbral THEN
        WriteLn ('Por lo tanto el autmata ACEPTA la palabra')
     ELSE
         Writeln ('El autmata NO acepta la palabra');
     Writeln;
     Writeln ('Pulse Escape para volver al men, u otra tecla para repetir ...');

END;

FUNCTION Menu: char;
BEGIN
     BorrarPantalla;
     WriteLn;
     Writeln ('                    ͻ ');
     Writeln ('                      AUTMATAS FINITOS PROBABILSTICOS   ');
     Writeln ('                    ͼ ');
     Writeln;
     Writeln;
     Writeln;
     Writeln;
     Writeln ('                              1.- Acepta una palabra    ');
     Writeln ('                              2.- Pasar a AFD           ');
     Writeln ('                              3.- Leer AFP de fichero   ');
     Writeln;
     Write ('                      Elige una opcin (Esc para salir) ...');
     Menu:= ReadKey;

END;

PROCEDURE Aceptar;
VAR
   c: char;
BEGIN
     REPEAT
           BorrarPantalla;
           writeln;
           WriteLn ('                         ACEPTAR UNA PALABRA ');
           WriteLn ('                         ------------------- ');
           Writeln;
           PedirDatos;
           CalcularPalabra;
           c:=ReadKey;
     UNTIL (c=chr(27));
END;

PROCEDURE Cargar_AFD;
VAR
   ficheroAFD: text;
   caracter: char;
   error: integer;
   i,j : integer;
BEGIN
     FOR i:=1 TO 11 DO
         FOR j:=1 TO 11 DO
             matrizAFD[i,j]:= ' ';

     ASSIGN ( ficheroAFD, 'a:\afd.txt' );
     RESET ( ficheroAFD );
     ReadLn ( ficheroAFD, caracter );
     Val ( caracter, numEstados, error );
     ReadLn ( ficheroAFD, caracter );
     Val (caracter, numEntradas, error );
     i:= 1;
     j:= 2;

     WHILE ( i<= NumEstados+1 ) DO
     BEGIN
           WHILE ( j<= NumEntradas+1 ) DO
           BEGIN
                ReadLn (ficheroAFD, matrizAFD[i,j]);
                j:=j+1;
           END;
           i:=i+1;
           j:=1;
     END;
     CLOSE ( ficheroAFD );

     ASSIGN ( ficheroAFD, 'a:\afdinfin.txt' );
     RESET ( ficheroAFD );
     ReadLn ( ficheroAFD, EstadoInicialAFD );
     ReadLn ( ficheroAFD, caracter );
     Val ( caracter, NumEstadosFinales , error );
     EstadosFinales.CrearVacia;
     FOR i:= 1 TO NumEstadosFinales DO
     BEGIN
          ReadLn ( ficheroAFD, caracter );
          EstadosFinales.Anadir (caracter);
     END;
     CLOSE ( ficheroAFD );

     writeln;
     writeln ('                 EL AFD LEIDO DEL FICHERO ES EL SIGUIENTE: ');
     writeln;

     FOR i:=1 TO NumEstados+1 DO
     BEGIN
         IF EstadoInicialAFD=matrizAFD[i,1] THEN
            IF (EstadosFinales.Posicion(matrizAFD[i,1])<>0) THEN
               write ('                          * -> ')
            ELSE
                write ('                            -> ')
         ELSE
             IF (EstadosFinales.Posicion(matrizAFD[i,1])<>0) THEN
                write ('                           *   ')
             ELSE
                 write ('                               ');
         FOR j:= 1 TO NumEntradas+1 DO
             write (matrizAFD[i,j], ' , ');
         writeln;
     END;
END;

PROCEDURE Obtener_AP;
VAR
   i, j, k: integer;
   numero, error: integer;
   car: char;
   matrizaux: matriz;
BEGIN

     (* ***************** Hallar las ENTRADAS del AFD *********** *)
     entrada.CrearVacia;
     FOR i:=2 TO NumEntradas+1 DO
     BEGIN
         val (matrizAFD[1,i], numero, error);
         entrada.Anadir ( numero );
     END;

     (* **************** Hallar los ESTADOS del AFD ************* *)
     estados.CrearVacia;
     FOR i:=2 TO NumEstados+1 DO
     BEGIN
         estados.Anadir ( matrizAFD[i,1] );
     END;

     (* *************** Hallar el VECTOR INICIAL del AFD ******** *)
     FOR i:=1 TO NumEstados DO
     BEGIN
         estados.Enesimo(i, car);
         IF car=EstadoInicialAFD THEN
            vectorInicial[i]:=1
         ELSE
             vectorInicial[i]:=0;
     END;

     (* ************** Hallar las MATRICES del AFD ************** *)
     matrices.CrearVacia;
     FOR i:= 1 TO NumEntradas DO
     BEGIN
          { Inicializar la matriz auxiliar }
          FOR j:=1 TO NumEstados DO
              FOR k:=1 TO NumEstados DO
              BEGIN
                   Estados.Enesimo (k,car);
                   IF car= matrizAFD[j+1,i+1] THEN
                      matrizaux[j,k]:= 1
                   ELSE
                       matrizaux[j,k]:=0;
              END;
          matrices.Anadir (matrizaux);
     END;
END;


PROCEDURE Mostrar_AP_Enteros;
VAR
   i: integer;
   numero: integer;
   caracter: char;
   matrizaux: matriz;
BEGIN
     writeln;
     write ('AFP= ({');
     FOR i:= 1 TO NumEntradas DO
     BEGIN
          Entrada.Enesimo(i, numero);
          write (numero);
          IF i<>NumEntradas THEN
             write (',');
     END;
     write ('}, {');
     FOR i:= 1 TO NumEstados DO
     BEGIN
          Estados.Enesimo(i, caracter);
          write (caracter);
          IF i<>NumEstados THEN
             write (',');
     END;
     write ('}, M, (');
     FOR i:= 1 TO NumEstados DO
     BEGIN
          write (VectorInicial[i]:1:0);
          IF i<>NumEstados THEN
             write (',');
     END;
     write ('), {');
     FOR i:= 1 TO NumEstadosFinales DO
     BEGIN
          EstadosFinales.Enesimo(i, caracter);
          write (caracter);
          IF i<>NumEstadosFinales THEN
             write (',');
     END;
     write ('}, Umbral )');
     writeln;
     FOR i:= 0 TO NumEntradas-1 DO
     BEGIN
          Matrices.Enesimo (i, matrizaux);
          MostrarMatriz ( matrizaux );
          writeln;
          IF i<>NumEntradas-1 THEN
             Readkey;
     END;

END;

PROCEDURE Mostrar_AP_Reales;
VAR
   i: integer;
   numero: integer;
   caracter: char;
   matrizaux: matriz;
BEGIN
     writeln;
     write ('AFP= ({');
     FOR i:= 1 TO NumEntradas DO
     BEGIN
          Entrada.Enesimo(i, numero);
          write (numero);
          IF i<>NumEntradas THEN
             write (',');
     END;
     write ('}, {');
     FOR i:= 1 TO NumEstados DO
     BEGIN
          Estados.Enesimo(i, caracter);
          write (caracter);
          IF i<>NumEstados THEN
             write (',');
     END;
     write ('}, M, (');
     FOR i:= 1 TO NumEstados DO
     BEGIN
          write (VectorInicial[i]:2:2);
          IF i<>NumEstados THEN
             write (',');
     END;
     write ('), {');
     FOR i:= 1 TO NumEstadosFinales DO
     BEGIN
          EstadosFinales.Enesimo(i, caracter);
          write (caracter);
          IF i<>NumEstadosFinales THEN
             write (',');
     END;
     write ('}, Umbral )');
     writeln;
     FOR i:= 0 TO NumEntradas-1 DO
     BEGIN
          Matrices.Enesimo (i, matrizaux);
          MostrarMatrizReales ( matrizaux );
          writeln;
          IF i<>NumEntradas-1 THEN
             Readkey;
     END;

END;

PROCEDURE Pasar;
VAR
   c: char;
BEGIN
     REPEAT
           BorrarPantalla;
           writeln;
           WriteLn ('                 PASAR UN AFD A AUTMATA PROBABILSTICO');
           WriteLn ('                 -------------------------------------- ');
           Writeln;
           Cargar_AFD;
           Obtener_AP;
           Mostrar_AP_Enteros;
           writeln;
           writeln ('Pulse Escape para volver al men, o cualquier tecla para repetir...');
           c:=ReadKey;

     UNTIL (c=chr(27));
END;

PROCEDURE Leer_Fichero;
BEGIN
     LeerFicheros;
     BorrarPantalla;
     writeln ('Autmata leido con xito: ');
     writeln;
     Mostrar_AP_Reales;
     writeln ('Pulse cualquier tecla para volver al men principal');
     readkey;
END;


BEGIN
     BorrarPantalla;
     LeerFicheros;
     REPEAT
           c:= Menu;
           CASE c OF
                '1': Aceptar;
                '2': Pasar;
                '3': Leer_Fichero;
           END;
     UNTIL c=chr(27);

END.