UNIT ListaEnt;

INTERFACE

TYPE
    TipoPosicion= byte;
    TipoElemento= integer;
    TipoPunt=^TipoElem;
    TipoElem= RECORD
                    nodo:TipoElemento;
                    siguiente:TipoPunt;
              END;

    TipoListaEnt= OBJECT
         PROCEDURE CrearVacia;
         (* POST: Crea una lista sin elementos: []                      *)
         FUNCTION EsVacia: boolean;
         (* POST: resultado= lista = []                                 *)
         {PROCEDURE Primero (var (*out*) elemento: TipoElemento;
                            var (*out*) s_ciud: TipoLista_Segunda);}
         (* PRE: NOT EsVacia (lista)                                    *)
         (* POST: resultado= Primer elemento de la lista                *)
{         PROCEDURE Resto;}
         (* PRE: NOT EsVacia (lista)                                    *)
         (* POST: Devuelve la lista resultante de eliminar su primer
                  elemento                                              *)
         PROCEDURE Enesimo ((*in*) posic: TipoPosicion;
                            var (*out*) elemento: TipoElemento);
         (* PRE: 1 <= posicion <= Longitud (Lista)                      *)
         (* POST: resultado= Elemento de la lista en una cierta
                             posicin                                   *)
         FUNCTION Longitud: TipoPosicion;
         (* POST: resultado= nmero de elementos de la lista            *)
         PROCEDURE Ultimo( var (*out*) elemento:TipoElemento);
         (* PRE: NOT EsVacia(lista)                                     *)
         (* POST: resultado= Enesimo(Longitud(lista),lista)             *)
         FUNCTION Pertenece ((*in*) elemento: TipoElemento): boolean;
         (* POST: resultado= devuelve si el elemento pertenece o no
                             a la lista                                 *)
         PROCEDURE BorrarElemento ((*in*) elemento: TipoElemento);
         (* POST: Elimina, si existe, la primera aparicin de elemento
                  en lista                                              *)
 {        FUNCTION Igual ((*in*) lista2: TipoListaEnt): boolean;}
         (* POST: resultado= (lista=lista2)                             *)
         PROCEDURE Iniciar;
         (* POST: Inicia el recorrido de una estructura                 *)
         PROCEDURE Avanzar;
         (* POST: Permite recorrer la estructura                        *)
         PROCEDURE Extraer ( var (*out*) elemento:TipoElemento);
         (* POST: Extrae el siguiente elemento del recorrido            *)
         FUNCTION Posicion ( (*in*) elemento: TipoElemento):TipoPosicion;
         (* POST: Devuelve la posicin de un elemento en la lista *)
         PROCEDURE Anadir ( elemento: TipoElemento);

         PRIVATE
                lista: TipoPunt;
                actual: TipoPunt;
                final: TipoPunt;
END;

IMPLEMENTATION

     PROCEDURE TipoListaEnt.CrearVacia;
     BEGIN
          lista:=NIL;
          actual:=NIL;
          final:=NIL;
     END;

     FUNCTION TipoListaEnt.EsVacia:boolean;
     BEGIN
          EsVacia:= (lista=nil);
     END;

     PROCEDURE TipoListaEnt.Enesimo ((*in*) posic: TipoPosicion;
                                         var (*out*) elemento: TipoElemento);
     VAR
        reflista: TipoPunt;
        num: TipoPosicion;
     BEGIN
          num:= posic;
          reflista:=lista;
          WHILE num > 1 DO
          BEGIN
               num:=num-1;
               reflista:=reflista^.siguiente
          END;
          elemento:=reflista^.nodo;
     END;

     FUNCTION TipoListaEnt.Longitud:TipoPosicion;
     VAR
        long: TipoPosicion;
        reflista: TipoPunt;
     BEGIN
          reflista:=lista;
          long:=1;
          WHILE (reflista^.siguiente<>NIL) DO
          BEGIN
               long:=long+1;
               reflista:=reflista^.siguiente;
          END;
          Longitud:=long;
     END;

     PROCEDURE TipoListaEnt.Ultimo( var (*out*) elemento: TipoElemento);
     BEGIN
          Enesimo (Longitud,elemento);
     END;

     FUNCTION TipoListaEnt.Pertenece ((*in*) elemento: TipoElemento):boolean;
     VAR
        reflista: TipoPunt;
        esta: boolean;
     BEGIN
          reflista:=lista;
          esta:=false;
          WHILE (reflista<>NIL) AND (NOT esta) DO
          BEGIN
               esta:= (reflista^.nodo=elemento);
               reflista:=reflista^.siguiente;
          END;
          Pertenece:= esta ;
     END;

     PROCEDURE TipoListaEnt.BorrarElemento ((*in*) elemento: TipoElemento);
     VAR
        reflista, refaux:TipoPunt;
        sw:boolean;
     BEGIN
          IF EsVacia THEN CrearVacia
          ELSE
          BEGIN
              reflista:=lista;
              sw:=FALSE;
              IF reflista^.nodo=elemento THEN
                 lista:=lista^.siguiente
              ELSE
              BEGIN
                   WHILE NOT(sw) AND (reflista^.siguiente<>NIL) DO
                   BEGIN
                        IF (reflista^.siguiente^.nodo=elemento) THEN
                           sw:=TRUE
                        ELSE
                            reflista:=reflista^.siguiente;
                   END;
                   IF sw THEN
                   BEGIN
                        refaux:=reflista^.siguiente;
                        reflista^.siguiente:=reflista^.siguiente^.siguiente;
                        reflista:=refaux;
                        dispose (reflista);
                   END;
              END;
          END;
     END;

     PROCEDURE TipoListaEnt.Iniciar;
     BEGIN
          actual:=lista;
     END;

     PROCEDURE TipoListaEnt.Avanzar;
     BEGIN
          actual:=actual^.siguiente;
     END;

     PROCEDURE TipoListaEnt.Extraer( var (*out*) elemento:TipoElemento);
     BEGIN
          elemento:= actual^.nodo;
     END;

     FUNCTION TipoListaEnt.Posicion ((*in*) elemento: TipoElemento):TipoPosicion;
     VAR
        reflista: TipoPunt;
        sw: boolean;
        cont: byte;
     BEGIN
          sw:=false;
          cont:=1;
          reflista:=lista;
          WHILE ((NOT sw) and (reflista<>NIL)) DO
          BEGIN
                IF reflista^.nodo=elemento THEN
                   sw:=true
                ELSE
                BEGIN
                    cont:=cont+1;
                    reflista:=reflista^.siguiente;
                END;
          END;
          IF sw=false THEN
             Posicion:=0
          ELSE
              Posicion:=cont;
     END;

     PROCEDURE TipoListaEnt.Anadir ( elemento: TipoElemento);
     VAR
        nuevo, reflista: TipoPunt;
     BEGIN
          new (nuevo);
          nuevo^.nodo:=elemento;
          nuevo^.siguiente:=NIL;
          IF (final=NIL) THEN
          BEGIN
               final:=nuevo;
               actual:=nuevo;
               lista:=nuevo;
          END
          ELSE
          BEGIN
               final^.siguiente:=nuevo;
               final:=nuevo;
          END;
          nuevo:=nil;
     END;
END.







