UNIT ListaMat;

INTERFACE

TYPE
    TipoPosicion= byte;
    valorMatriz = real;
    matriz = ARRAY [1..10,1..10] of valorMatriz;
    TipoElemento= matriz;
    TipoPunt=^TipoElem;
    TipoElem= RECORD
                    nodo:TipoElemento;
                    siguiente:TipoPunt;
              END;

    TipoListaMat= OBJECT
         PROCEDURE CrearVacia;
         (* POST: Crea una lista sin elementos: []                      *)
         PROCEDURE Construir ((*in*) elemento:TipoElemento);
         (* POST: Construye una lista, dados un elemento y una lista    *)
         PROCEDURE Enesimo ((*in*) posic: TipoPosicion;
                            var (*out*) elemento: TipoElemento);
         (* PRE: 1 <= posicion <= Longitud (Lista)                      *)
         (* POST: resultado= Elemento de la lista en una cierta
                             posicin                                   *)
         FUNCTION Longitud: TipoPosicion;
         (* POST: resultado= nmero de elementos de la lista            *)
         PROCEDURE Ultimo( var (*out*) elemento:TipoElemento);
         (* PRE: NOT EsVacia(lista)                                     *)
         (* POST: resultado= Enesimo(Longitud(lista),lista)             *)
         PROCEDURE Iniciar;
         (* POST: Inicia el recorrido de una estructura                 *)
         PROCEDURE Avanzar;
         (* POST: Permite recorrer la estructura                        *)
         PROCEDURE Extraer ( var (*out*) elemento:TipoElemento);
         (* POST: Extrae el siguiente elemento del recorrido            *)
         PROCEDURE Anadir ( elemento: TipoElemento);
         PRIVATE
                lista: TipoPunt;
                actual: TipoPunt;
                final: TipoPunt;
END;

IMPLEMENTATION

     PROCEDURE TipoListaMat.CrearVacia;
     BEGIN
          lista:=NIL;
          actual:=NIL;
          final:=NIL;
     END;

     PROCEDURE TipoListaMat.Construir ((*in*) elemento: TipoElemento);
     VAR
        nuevo: TipoPunt;
     BEGIN
        New (nuevo);
        nuevo^.nodo:=elemento;
        nuevo^.siguiente:=NIL;
        actual:=nuevo;
        lista:=nuevo;
        final:=nuevo;
        nuevo:=nil;
     END;
     PROCEDURE TipoListaMat.Enesimo ((*in*) posic: TipoPosicion;
                            var (*out*) elemento: TipoElemento);
     VAR
        reflista: TipoPunt;
        num: TipoPosicion;
     BEGIN
          num:= posic;
          reflista:=lista;
          WHILE num > 0 DO
          BEGIN
               num:=num-1;
               reflista:=reflista^.siguiente
          END;
          elemento:=reflista^.nodo;
     END;

     FUNCTION TipoListaMat.Longitud:TipoPosicion;
     VAR
        long: TipoPosicion;
        reflista: TipoPunt;
     BEGIN
          reflista:=lista;
          long:=1;
          WHILE (reflista^.siguiente<>NIL) DO
          BEGIN
               long:=long+1;
               reflista:=reflista^.siguiente;
          END;
          Longitud:=long;
     END;

     PROCEDURE TipoListaMat.Ultimo( var (*out*) elemento:TipoElemento);
     BEGIN
          Enesimo (Longitud,elemento);
     END;

     PROCEDURE TipoListaMat.Iniciar;
     BEGIN
          actual:=lista;
     END;

     PROCEDURE TipoListaMat.Avanzar;
     BEGIN
          actual:=actual^.siguiente;
     END;

     PROCEDURE TipoListaMat.Extraer ( var (*out*) elemento:TipoElemento);
     BEGIN
          elemento:= actual^.nodo;
     END;

     PROCEDURE TipoListaMat.Anadir ( elemento: TipoElemento);
     VAR
        nuevo, reflista: TipoPunt;
     BEGIN
          new (nuevo);
          nuevo^.nodo:=elemento;
          nuevo^.siguiente:=NIL;
          IF (final=NIL) THEN
          BEGIN
               lista:=nuevo;
               final:=nuevo;
               actual:=nuevo;
          END
          ELSE
          BEGIN
               final^.siguiente:=nuevo;
               final:=nuevo;
          END;
          nuevo:=nil;
     END;
END.







